<?php

declare(strict_types=1);

namespace Dedi\SyliusBannerPlugin\Twig;

use Dedi\SyliusBannerPlugin\Entity\AlertMessageEnum;
use Dedi\SyliusBannerPlugin\Repository\AlertMessageRepositoryInterface;
use Twig\Extension\AbstractExtension;
use Twig\TwigFunction;

final class AlertMessageRetrieverExtension extends AbstractExtension
{
    private AlertMessageRepositoryInterface $alertMessageRepository;

    public function __construct(
        AlertMessageRepositoryInterface $alertMessageRepository
    ) {
        $this->alertMessageRepository = $alertMessageRepository;
    }

    public function getFunctions(): array
    {
        return [
            new TwigFunction(
                'dedi_banner_retrieve_available_alert_messages',
                fn (): array => $this->alertMessageRepository->getAvailableAlertMessages(AlertMessageEnum::TOP_BAR)
            ),
            new TwigFunction(
                'dedi_banner_retrieve_available_basket_alert_messages',
                fn (): array => $this->alertMessageRepository->getAvailableAlertMessages(AlertMessageEnum::CART)
            ),
        ];
    }
}
